#include <stdio.h>
#include <stdlib.h>

typedef struct ListNode {
  void* value;
  int value_size;
  struct ListNode* prev;
  struct ListNode* next;
} ListNode;

typedef struct LinkedList {
  int count;
  ListNode* root;
} LinkedList;

LinkedList* LinkedList_create(void* data, int size);
  
void LinkedList_add(LinkedList* ll, void* data, int size);

void LinkedList_print(LinkedList* ll);

bool LinkedList_contains(LinkedList* ll, void* data, int size);

void LinkedList_delete(LinkedList* ll);

